--- /dev/null	Sat Apr 20 14:17:50 2013
+++ new/usr/src/cmd/sgs/getlogin8/common/getlogin8.c	Sat Apr 20 14:17:50 2013
@@ -0,0 +1,58 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License, Version 1.0 only
+ * (the "License").  You may not use this file except in compliance
+ * with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ *	Copyright (c) 2013 Gary Mills
+ *
+ *	Copyright (c) 1996 by Sun Microsystems, Inc.
+ *
+ * Truncate a long login name returned by getlogin()
+ * for programs that copy the name to a nine-byte buffer.
+ *
+ * Use:
+ *	LD_PRELOAD=getlogin8.so.1 program args ...
+ *
+ */
+
+#include <unistd.h>
+#include <dlfcn.h>
+#include <string.h>
+
+/* Traditional length limit */
+#define	TRAD_LEN_MAX	8
+
+char *
+getlogin(void)
+{
+	static char *(*getlogin_addr)(void) = NULL;
+	static char buffer[TRAD_LEN_MAX + 1];
+	char *p;
+
+	if (getlogin_addr == NULL)
+		getlogin_addr = (char *(*)(void))dlsym(RTLD_NEXT,
+		    "getlogin");
+	if ((p = (*getlogin_addr)()) == NULL)
+		return (NULL);
+	(void)strlcpy(buffer, p, sizeof (buffer));
+	return (buffer);
+}
+
+/* */
